<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Backend extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		if( !isset($this->session->userdata['ts_uid']) ) {
		    redirect(base_url());
		}
		if( isset($this->session->userdata['ts_uid']) ) {
    		if($this->session->userdata['ts_level'] != 1) {
			    redirect(base_url());
			}
		}
		if(isset($_POST) && !empty($_POST)) {
	        if(!isset($_SERVER['HTTP_REFERER'])) {
                die('Direct Access Not Allowed!!');
	        }
	    }
	    $this->load->library('ts_functions');
	}

	public function index(){
		$data['basepath'] = base_url();

        $data['userdetails_active'] = $this->DatabaseModel->access_database('ts_user','select','',array('user_status'=>1,'user_accesslevel'=>2));
        $data['userdetails_inactive'] = $this->DatabaseModel->access_database('ts_user','select','',array('user_status'=>2,'user_accesslevel'=>2));
        $data['userdetails_blocked'] = $this->DatabaseModel->access_database('ts_user','select','',array('user_status'=>3,'user_accesslevel'=>2));

        $data['productdetails_active'] = $this->DatabaseModel->access_database('ts_products','select','',array('prod_status'=>1));
        $data['productdetails_free'] = $this->DatabaseModel->access_database('ts_products','select','',array('prod_status'=>1,'prod_free'=>1));

        $data['activePlans'] = $this->DatabaseModel->access_database('ts_plans','select','',array('plan_status'=>1));
        $data['emaillist_uniq'] = $this->DatabaseModel->access_database('ts_emaillist','groupby','e_email','');

        if( !isset($_POST['duration'])) {
            $data['userdetails'] = $this->DatabaseModel->access_database('ts_user','select','',array('user_accesslevel'=>2));
            $data['prodViews'] = $this->DatabaseModel->access_database('ts_product_analysis','select','','');
            $data['prodSales'] = $this->DatabaseModel->access_database('ts_purchaserecord','select','','');
            $data['emaillist'] = $this->DatabaseModel->access_database('ts_emaillist','select','','');

            $data['duration'] = $data['d1'] = $data['d2'] = '';
        }
        else if(isset($_POST['duration'])) {

            if( $_POST['duration'] == '' ) {
                $data['userdetails'] = $this->DatabaseModel->access_database('ts_user','select','',array('user_accesslevel'=>2));
                $data['prodViews'] = $this->DatabaseModel->access_database('ts_product_analysis','select','','');
                $data['prodSales'] = $this->DatabaseModel->access_database('ts_purchaserecord','select','','');
                $data['emaillist'] = $this->DatabaseModel->access_database('ts_emaillist','select','','');

            }
            elseif($_POST['duration'] == 'today'){
                $todaydate = date('Y-m-d');

                $havingArr = array('user_accesslevel'=>2);
                $like_arr = array('user_registerdate'=>$todaydate);
                $data['userdetails'] = $this->DatabaseModel->access_database('ts_user','like',$havingArr,$like_arr);

                $like_arr = array('prod_analysis_date'=>$todaydate);
                $data['prodViews'] = $this->DatabaseModel->access_database('ts_product_analysis','like','',$like_arr);

                $like_arr = array('purrec_date'=>$todaydate);
                $data['prodSales'] = $this->DatabaseModel->access_database('ts_purchaserecord','like','',$like_arr);

                $like_arr = array('e_date'=>$todaydate);
                $data['emaillist'] = $this->DatabaseModel->access_database('ts_emaillist','like','',$like_arr);

            }
            elseif($_POST['duration'] == 'yesterday'){
                $yesterdate = date('Y-m-d',strtotime("-1 days"));

                $havingArr = array('user_accesslevel'=>2);
                $like_arr = array('user_registerdate'=>$yesterdate);
                $data['userdetails'] = $this->DatabaseModel->access_database('ts_user','like',$havingArr,$like_arr);

                $like_arr = array('prod_analysis_date'=>$yesterdate);
                $data['prodViews'] = $this->DatabaseModel->access_database('ts_product_analysis','like','',$like_arr);

                $like_arr = array('purrec_date'=>$yesterdate);
                $data['prodSales'] = $this->DatabaseModel->access_database('ts_purchaserecord','like','',$like_arr);

                $like_arr = array('e_date'=>$yesterdate);
                $data['emaillist'] = $this->DatabaseModel->access_database('ts_emaillist','like','',$like_arr);
            }
            elseif($_POST['duration'] == 'custom'){
                $fromdate = date_format(date_create ( $_POST['d1'] ) , 'Y-m-d H:i:s');
                $todate = date_format(date_create ( $_POST['d2'] ) , 'Y-m-d H:i:s');

                $whr = array(
                        'user_registerdate >=' =>  $fromdate,
                        'user_registerdate <=' =>  $todate,
                        'user_accesslevel'=>2
                );
                $data['userdetails'] = $this->DatabaseModel->access_database('ts_user','select','',$whr);

                $whr = array(
                        'prod_analysis_date >=' =>  $fromdate,
                        'prod_analysis_date <=' =>  $todate
                );
                $data['prodViews'] = $this->DatabaseModel->access_database('ts_product_analysis','select','',$whr);

                $whr = array(
                        'purrec_date >=' =>  $fromdate,
                        'purrec_date <=' =>  $todate
                );
                $data['prodSales'] = $this->DatabaseModel->access_database('ts_purchaserecord','select','',$whr);

                $whr = array(
                        'e_date >=' =>  $fromdate,
                        'e_date <=' =>  $todate
                );
                $data['emaillist'] = $this->DatabaseModel->access_database('ts_emaillist','select','',$whr);

            }
            $data['duration'] = $_POST['duration'];
            $data['d1'] = $_POST['d1'];
            $data['d2'] = $_POST['d2'];
        }


        $this->load->view('backend/include/header',$data);
        $this->load->view('backend/myboard',$data);
	}

    /****************** Change Admin Password STARTS *********************/

    function admin_change_password(){
        if(isset($_POST['old_pwd'])) {
            $userDetail = $this->DatabaseModel->access_database('ts_user','select','',array('user_accesslevel'=>1,'user_pwd'=>md5($_POST['old_pwd'])));
            if(!empty($userDetail)){
                $this->DatabaseModel->access_database('ts_user','update',array('user_pwd'=>md5($_POST['new_pwd'])),array('user_id'=>$userDetail[0]['user_id']));
                echo '1';
            }
            else {
                echo '0';
            }
        }
        else {
            echo '0';
        }
        die();
    }
    /****************** Change Admin Password ENDS *********************/

    /****************** User List STARTS *********************/
	public function users(){
		$data['basepath'] = base_url();
		$data['userdetails'] = $this->DatabaseModel->access_database('ts_user','select','',array('user_accesslevel !='=>1));
		$this->load->view('backend/include/header',$data);
		$this->load->view('backend/users',$data);
		$this->load->view('backend/include/footer',$data);
	}
    /****************** User List ENDS *********************/

    /************* Single User details STARTS ********************/
	public function single_user($uid=''){
		$data['basepath'] = base_url();
		$data['userdetails'] = $this->DatabaseModel->access_database('ts_user','select','',array('user_accesslevel !='=>1,'user_id'=>$uid));
		$freeProducts = $this->DatabaseModel->access_database('ts_products','select','',array('prod_free'=>1,'prod_status'=>1));

		$join_array = array('ts_products','ts_products.prod_id = ts_purchaserecord.purrec_prodid');
		$purchasedDetails = $this->DatabaseModel->access_database('ts_purchaserecord','','',array('purrec_uid'=>$uid,'prod_status'=>1),$join_array);

        if( $this->ts_functions->getsettings('portal','revenuemodel') == 'subscription' ) {

            $userDetail = $this->DatabaseModel->access_database('ts_user','select','',array('user_id'=>$uid));

            $userPlan = $userDetail[0]['user_plans'];
            $totalProducts = $this->DatabaseModel->access_database('ts_products','select','',array('prod_status'=>1,'prod_free'=>0));

            $planProducts = array();
            if(!empty($totalProducts))
            {
                foreach($totalProducts as $solo_prod) {
                    if( strpos($solo_prod['prod_plan'].',',$userPlan.',') !== FALSE ) {
                        array_push($planProducts,$solo_prod);
                    }
                }
            }
        }
        else {
            $planProducts = array();
        }

		$purchasedDetails = array_merge($purchasedDetails,$planProducts);

		$data['totalProductDetails'] = array_merge($purchasedDetails,$freeProducts);
		$this->load->view('backend/include/header',$data);
		$this->load->view('backend/single_user',$data);
		$this->load->view('backend/include/footer',$data);
	}

    /************* Single User details ENDS ********************/

	public function portalrevenue(){
		$data['basepath'] = base_url();
		$data['plandetails'] = $this->DatabaseModel->access_database('ts_plans','select','','');
		$this->load->view('backend/include/header',$data);
		$this->load->view('backend/portalrevenue',$data);
		$this->load->view('backend/include/footer',$data);
	}

	/**** Ajax function to handel subscription plan updates ****/
    public function update_plantable() {
	    if(isset($_POST['planupdate'])) {
	        $updatedata = json_decode($_POST['updatedata']);
	            $nID = '0';
	        foreach( $updatedata as $soloKey=>$soloValue ) {
	            if( strpos($soloKey,'V') === false ) {
                    $colArr = explode('#',$soloKey);
                    if( count($colArr) == 2 ) {
                        $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$soloValue),array('plan_id'=>$colArr[1]));
                    }
                    else {
                        if( $colArr[0] == 'plan_duration' ) {
                            if( $soloValue == 'Life Time' ) {
                                $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$soloValue),array('plan_id'=>$colArr[2]));
                            }
                            else {
                                $nKey1 = $colArr[0].'#num#'.$colArr[2];
                                $nkey2 = $colArr[0].'#period#'.$colArr[2];
                                $colValue = $updatedata->$nKey1.' '.$updatedata->$nkey2;
                                $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$colValue),array('plan_id'=>$colArr[2]));
                            }
                        }
                        /***********************/

                        if( $colArr[0] == 'plan_product' ) {
                            if( $soloValue == 'All' ) {
                                $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$soloValue),array('plan_id'=>$colArr[2]));
                            }
                            else {
                                $nKey1 = $colArr[0].'#num#'.$colArr[2];
                                $colValue = $updatedata->$nKey1;
                                $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$colValue),array('plan_id'=>$colArr[2]));
                            }
                        }
                    }
	            }
	            else {
	                // New data
	                $colArr = explode('#',$soloKey);
                    if( count($colArr) == 2 ) {
                        if($nID == '0') {
                            $nID = $this->DatabaseModel->access_database('ts_plans','insert',array($colArr[0]=>$soloValue),'');
                        }
                        else {
                            $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$soloValue),array('plan_id'=>$nID));
                        }
                    }
                    else {
                        if( $colArr[0] == 'plan_duration' ) {
                            if( $soloValue == 'Life Time' ) {
                                $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$soloValue),array('plan_id'=>$nID));
                            }
                            else {
                                $nKey1 = $colArr[0].'#num#'.$colArr[2];
                                $nkey2 = $colArr[0].'#period#'.$colArr[2];
                                $colValue = $updatedata->$nKey1.' '.$updatedata->$nkey2;
                                $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$colValue),array('plan_id'=>$nID));
                            }
                        }
                        /***********************/

                        if( $colArr[0] == 'plan_product' ) {
                            if( $soloValue == 'All' ) {
                                $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$soloValue),array('plan_id'=>$nID));
                            }
                            else {
                                $nKey1 = $colArr[0].'#num#'.$colArr[2];
                                $colValue = $updatedata->$nKey1;
                                $this->DatabaseModel->access_database('ts_plans','update',array($colArr[0]=>$colValue),array('plan_id'=>$nID));
                            }
                        }
                    }
	            }
	        }
	        echo '1';
	    }
	    else {
	        echo '0';
	    }
	    die();
	}

	/****** Email Section STARTS **************/

	public function email_integrations() {
	    $data['basepath'] = base_url();
	    $res_em_resp = $this->DatabaseModel->access_database('ts_emailproviders','select','','');
        $data['emailresponders'] = $res_em_resp;

        //$all_responders = array('CampaignMonitor','ConstantContact','GetResponse','Mailchimp','SendReach','iContact','Infusionsoft','Hubspot','Aweber','ActiveCampaign','Sendlane','Benchmark','Sendy','Madmimi','Sendinblue');
        $all_responders = array('ConstantContact','GetResponse','Mailchimp','Aweber','Sendinblue');

        $connect_resp = array();
        if(!empty($res_em_resp)) {
            foreach($res_em_resp as $solo_resp) {
                $connect_resp[] = $solo_resp['ep_name'];
            }
            $left_respon = array_diff($all_responders, $connect_resp);
            //array_push($left_respon);
        }
        else {
            $left_respon = $all_responders;
        }

        $data['left_responders'] = $left_respon;
	    $this->load->view('backend/include/header',$data);
		$this->load->view('backend/email_integrations',$data);
		$this->load->view('backend/include/footer',$data);
	}

	public function email_integrations_ajx() {
	    if(isset($_POST['emAppId'])) {

        if( $_POST['emAppId'] == 'Mailchimp') {
            // Mailchimp Autoresponder

            require_once 'emailIntegration_resources/Mailchimp/MCAPI.class.php';

            $list = array();
            if ( $_POST['Mailchimp_apikey'])
            {

                $api = new MCAPI($_POST['Mailchimp_apikey']);
                $retval = $api->lists();
                if (!$api->errorCode)
                {
                    if($retval['data'] != 0){
                        foreach ($retval['data'] as $v)
                        {
                            $list[$v['id']] = $v['name'];
                        }

                        $insertArr = array(
                            'ep_name'   =>  $_POST['emAppId']
                        );

                        $res = $this->DatabaseModel->access_database('ts_emailproviders','select','',$insertArr);

                        if( empty($res)) {
                            $insertArr['ep_credentials'] = json_encode(array('Mailchimp_apikey'=>$_POST['Mailchimp_apikey']));

                            $resID = $this->DatabaseModel->access_database('ts_emailproviders','insert',$insertArr,'');
                        }
                        else {
                             $resID = $res[0]['ep_id'];

                             $updateArr['ep_credentials'] = json_encode(array('Mailchimp_apikey'=>$_POST['Mailchimp_apikey']));
                             $this->DatabaseModel->access_database('ts_emailproviders','update',$updateArr,array('ep_id'=>$resID));
                        }

                        $this->DatabaseModel->access_database('ts_eplist','delete','',array('eplist_parentid'=>$resID));

                        foreach($list as $key=>$val) {

                            $listInsertArr = array(
                                'eplist_parentid' =>  $resID,
                                'eplist_uniqid' =>  $key,
                                'eplist_name' =>  $val
                            );
                            $this->DatabaseModel->access_database('ts_eplist','insert',$listInsertArr,'');
                        }

                    }
                    else {
                        echo 'ZERO'; // When no list found
                    }
                }
                else {
                    echo '404';
                }
            }
            else {
                echo '404';
            }

        }
        elseif( $_POST['emAppId'] == 'GetResponse') {
            // Get_Response Autoresponder

            require_once 'emailIntegration_resources/GetResponse/jsonRPCClient.php';

            $list = array();
            if ( $_POST['GetResponse_apikey'])
            {
                $api = new jsonRPCClient('http://api2.getresponse.com');
                try
                {
                    $result = $api->get_campaigns($_POST["GetResponse_apikey"]);
                    if( count($result) > 0 ) {

                        $insertArr = array(
                                'ep_name'   =>  $_POST['emAppId']
                        );

                        $res = $this->DatabaseModel->access_database('ts_emailproviders','select','',$insertArr);

                        if( empty($res)) {
                            $insertArr['ep_credentials'] = json_encode(array('GetResponse_apikey'=>$_POST['GetResponse_apikey']));


                            $resID = $this->DatabaseModel->access_database('ts_emailproviders','insert',$insertArr,'');
                        }
                        else {
                             $resID = $res[0]['ep_id'];

                             $updateArr['ep_credentials'] = json_encode(array('GetResponse_apikey'=>$_POST['GetResponse_apikey']));

                             $this->DatabaseModel->access_database('ts_emailproviders','update',$updateArr,array('ep_id'=>$resID));
                        }

                        $this->DatabaseModel->access_database('ts_eplist','delete','',array('eplist_parentid'=>$resID));

                        foreach ($result as $k => $v)
                        {
                            $list_key = $k;
                            $list_name = $v['name'];

                            $listInsertArr = array(
                                'eplist_parentid' =>  $resID,
                                'eplist_uniqid' =>  $list_key,
                                'eplist_name' =>  $list_name
                            );
                            $this->DatabaseModel->access_database('ts_eplist','insert',$listInsertArr,'');
                        }
                    }
                    else {
                        echo 'ZERO'; // When no list found
                    }
                }
                catch (Exception $e)
                {
                   echo '404'; // Invalid API key
                }
            }
            else {
                echo '404';
            }

        }
        elseif( $_POST['emAppId'] == 'Aweber') {
            // Aweber Autoresponder


            if ( isset ($_POST['Aweber_code']) )
            {
                require_once 'emailIntegration_resources/Aweber/aweber_api.php';
                $data_arr = array();

                $descr = '';
                try
                {
                    list($consumer_key, $consumer_secret, $access_key, $access_secret) = AWeberAPI::getDataFromAweberID($_POST['Aweber_code']);
                }
                catch (AWeberAPIException $exc)
                {
                    list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
                    if(isset($exc->message))
                    {
                        $descr = $exc->message;
                        $descr = preg_replace('/http.*$/i', '', $descr);	 # strip labs.aweber.com documentation url from error message
                        $descr = preg_replace('/[\.\!:]+.*$/i', '', $descr); # strip anything following a . : or ! character
                        $descr = '('.$descr.')';

                    }
                }
                catch (AWeberOAuthDataMissing $exc)
                {
                    list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
                }
                catch (AWeberException $exc)
                {
                    list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
                }

                if (!$access_secret)
                {
                    echo '404';
                }
                else
                {
                    $aweber = new AWeberAPI($consumer_key, $consumer_secret);
                    $account = $aweber->getAccount($access_key, $access_secret);
                    $aweber_result = $account->lists;
                    if( $aweber_result->data['total_size'] != '' && $aweber_result->data['total_size'] != 0 )
                    {

                        $insertArr = array(

                                'ep_name'   =>  $_POST['emAppId']
                        );

                        $res = $this->DatabaseModel->access_database('ts_emailproviders','select','',$insertArr);

                        if( empty($res)) {
                            $insertArr['ep_credentials'] = json_encode(array('Aweber_consumer_key'=>$consumer_key,'Aweber_consumer_secret'=>$consumer_secret,'Aweber_access_key'=>$access_key,'Aweber_access_secret'=>$access_secret));


                            $resID = $this->DatabaseModel->access_database('ts_emailproviders','insert',$insertArr,'');
                        }
                        else {
                             $resID = $res[0]['ep_id'];

                             $updateArr['ep_credentials'] = json_encode(array('Aweber_consumer_key'=>$consumer_key,'Aweber_consumer_secret'=>$consumer_secret,'Aweber_access_key'=>$access_key,'Aweber_access_secret'=>$access_secret));

                             $this->DatabaseModel->access_database('ts_emailproviders','update',$updateArr,array('ep_id'=>$resID));
                        }

                        $this->DatabaseModel->access_database('ts_eplist','delete','',array('eplist_parentid'=>$resID));


                        foreach ($aweber_result->data['entries'] as $solo_list)
                        {
                             $listInsertArr = array(
                                'eplist_parentid' =>  $resID,
                                'eplist_uniqid' =>  $solo_list['id'],
                                'eplist_name' =>  $solo_list['name']
                            );
                            $this->DatabaseModel->access_database('ts_eplist','insert',$listInsertArr,'');
                        }
                    }
                    else {
                        echo 'ZERO';
                    }

                }

            }
            else {
                echo '404';
            }

        }
        elseif( $_POST['emAppId'] == 'ConstantContact') {

            // ConstantContact Autoresponder
            require_once 'emailIntegration_resources/ConstantContact/class.cc.php';
            $cc = new cc($_POST["ConstantContact_uname"], $_POST["ConstantContact_pwd"]);

            $resultofcc = $cc->get_lists('lists');


            if ($resultofcc)
            {

                if( count($resultofcc) > 0 ) {
                    $insertArr = array(

                            'ep_name'   =>  $_POST['emAppId']
                    );

                    $res = $this->DatabaseModel->access_database('ts_emailproviders','select','',$insertArr);

                    if( empty($res)) {
                        $insertArr['ep_credentials'] = json_encode(array('ConstantContact_uname'=>$_POST['ConstantContact_uname'],'ConstantContact_pwd'=>$_POST['ConstantContact_pwd']));


                        $resID = $this->DatabaseModel->access_database('ts_emailproviders','insert',$insertArr,'');
                    }
                    else {
                         $resID = $res[0]['ep_id'];

                         $updateArr['ep_credentials'] = json_encode(array('ConstantContact_uname'=>$_POST['ConstantContact_uname'],'ConstantContact_pwd'=>$_POST['ConstantContact_pwd']));

                         $this->DatabaseModel->access_database('ts_emailproviders','update',$updateArr,array('ep_id'=>$resID));
                    }

                    $this->DatabaseModel->access_database('ts_eplist','delete','',array('eplist_parentid'=>$resID));


                    foreach($resultofcc as $list){

                            $listInsertArr = array(
                                'eplist_parentid' =>  $resID,
                                'eplist_uniqid' =>  $list['id'],
                                'eplist_name' =>  $list['Name']
                            );
                            $this->DatabaseModel->access_database('ts_eplist','insert',$listInsertArr,'');
                    }

                }
                else {
                    echo 'ZERO';
                }
            }
            else
            {
                echo '404';
            }

        }
        elseif( $_POST['emAppId'] == 'Sendinblue') {
            // Sendinblue Autoresponder

            if ( isset($_POST['Sendinblue_apikey']) )
            {

                $apikey = $_POST['Sendinblue_apikey'];
                require_once 'emailIntegration_resources/Sendinblue/Mailin.php';

	            $mailin = new Mailin('https://api.sendinblue.com/v2.0',$apikey);

                $data = array(
                  "page" => 1,
                  "page_limit" => 50
                );
                $retvals = $mailin->get_lists($data);
                if( $retvals['code'] == 'success' ) {
                    if( count($retvals['data']['lists']) > 0 ) {

                        $insertArr = array(

                                'ep_name'   =>  $_POST['emAppId']
                        );

                        $res = $this->DatabaseModel->access_database('ts_emailproviders','select','',$insertArr);

                        if( empty($res)) {
                            $insertArr['ep_credentials'] = json_encode(array('Sendinblue_apikey'=>$_POST['Sendinblue_apikey']));


                            $resID = $this->DatabaseModel->access_database('ts_emailproviders','insert',$insertArr,'');
                        }
                        else {
                             $resID = $res[0]['ep_id'];

                             $updateArr['ep_credentials'] = json_encode(array('Sendinblue_apikey'=>$_POST['Sendinblue_apikey']));

                             $this->DatabaseModel->access_database('ts_emailproviders','update',$updateArr,array('ep_id'=>$resID));
                        }
                        $this->DatabaseModel->access_database('ts_eplist','delete','',array('eplist_parentid'=>$resID));
                        foreach($retvals['data']['lists'] as $retval)
                        {
                            $listInsertArr = array(
                                'eplist_parentid' =>  $resID,
                                'eplist_uniqid' =>  $retval['id'],
                                'eplist_name' =>  $retval['name']
                            );
                            $this->DatabaseModel->access_database('ts_eplist','insert',$listInsertArr,'');

                        }
                    }
                    else {
                        echo 'ZERO';
                    }
                }
                else {
                    echo '404';
                }
            }
            else {
                echo '404';
            }


        }

        }
        die();
	}

    public function saveListToConnect() {
        if(isset($_POST['jsondata'])) {
            $jsondata = json_decode($_POST['jsondata']);
            foreach($jsondata as $key=>$val) {
                $this->ts_functions->updatesettings($key,$val);
            }
            if($_POST['elistStr'] != '') {
                $ress = $this->DatabaseModel->access_database('ts_eplist','select','','');
                if(!empty($ress)) {
                    foreach($ress as $soloress) {
                        $dataArr1 = array('eplist_use'=>0);
                        $whrArr1 = array('eplist_id'=>$soloress['eplist_id']);
                        $this->DatabaseModel->access_database('ts_eplist','update',$dataArr1,$whrArr1);
                    }
                }
                $strArr = explode('@#',$_POST['elistStr']);
                for($i=0;$i<count($strArr);$i++) {
                    if($strArr[$i] != '') {
                        $dataArr = array('eplist_use'=>1);
                        $whrArr = array('eplist_id'=>$strArr[$i]);
                        $this->DatabaseModel->access_database('ts_eplist','update',$dataArr,$whrArr);
                    }
                }
            }

            echo '1';
        }
        else {
            echo '0';
        }
        die();
    }


	public function email_list() {
	    $data['basepath'] = base_url();
	    $joinArr = array('ts_eplist','ts_eplist.eplist_id = ts_emaillist.e_list');
	    $listusers = $this->DatabaseModel->access_database('ts_emaillist','','','',$joinArr);

	    $listusers1 = $this->DatabaseModel->access_database('ts_emaillist','select','',array('e_list'=>0));
        $data['listusers'] = array_merge($listusers,$listusers1);
	    $this->load->view('backend/include/header',$data);
		$this->load->view('backend/email_list',$data);
		$this->load->view('backend/include/footer',$data);
	}

	public function email_list_export($type='') {
	    if($type != '') {

	        $filename = 'Email-List.'.$type;
            $joinArr = array('ts_eplist','ts_eplist.eplist_id = ts_emaillist.e_list');
	        $result1 = $this->DatabaseModel->access_database('ts_emaillist','','','',$joinArr);

	        $result2 = $this->DatabaseModel->access_database('ts_emaillist','select','',array('e_list'=>0));

	        $result = array_merge($result1,$result2);

	        $col_arr = array('Index','Email','List Name','Type','Date');
	        if(!empty($result)) {
	                $str = '';
	                $count=0;

                if( $type == 'csv' ) {
                    $filename = 'Email-List.csv';
                    header('Content-Type: text/csv; charset=utf-8');
                    header('Content-Disposition: attachment; filename='.$filename);

                    foreach($result as $soloRes) {
                        $elistname = ( $soloRes['e_list'] != '0' ) ? $soloRes['eplist_name'] : '-' ;
                        $count++;
                        $str .= $count.",".$soloRes['e_email'].",".$elistname.",".$soloRes['e_type'].",".date_format(date_create ( $soloRes['e_date'] ) , 'M d Y')."\r\n";
                    }
                    echo implode(",", $col_arr) . "\r\n";

                    echo $str;

                }
                else {

                    $filename = 'Email-List.xls';
                    header("Content-Disposition: attachment; filename=".$filename);
                    header("Content-Type: application/vnd.ms-excel");
                    foreach($result as $soloRes) {
                        $elistname = ( $soloRes['e_list'] != '0' ) ? $soloRes['eplist_name'] : '-' ;
                        $count++;
                        $str .= $count."\t".$soloRes['e_email']."\t".$elistname."\t".$soloRes['e_type']."\t".date_format(date_create ( $soloRes['e_date'] ) , 'M d, Y')."\r\n";
                    }
                    echo implode("\t", $col_arr) . "\r\n";

                    echo $str;
                }

            }
            else {
                 redirect(base_url().'backend/email_list');
            }
	    }
	    else {
             redirect(base_url().'backend/email_list');
        }
	}


	public function email_templates() {
	    if(isset($_POST['logoshow'])) {
	        $type = $_POST['type'];
	        $this->ts_functions->updatesettings($type.'_logoshow',$_POST['logoshow']);
	        if( isset($_POST['emText']) ) {
	            $this->ts_functions->updatesettings($type.'_text',$_POST['emText']);
	            $this->ts_functions->updatesettings($type.'_linktext',$_POST['linktext']);
	        }
	        else if( isset($_POST['fromname']) ) {
	            $this->ts_functions->updatesettings($type.'_fromname',$_POST['fromname']);
	            $this->ts_functions->updatesettings($type.'_fromemail',$_POST['fromemail']);
	            $this->ts_functions->updatesettings($type.'_replytoshow',$_POST['replytoshow']);
	            $this->ts_functions->updatesettings($type.'_replyemail',$_POST['replyemail']);
	            $this->ts_functions->updatesettings($type.'_contactemail',$_POST['contactemail']);
	        }

	        echo '1';
	        die();
	    }
	    else
	    {
            $data['basepath'] = base_url();
            $this->load->view('backend/include/header',$data);
            $this->load->view('backend/email_templates',$data);
            $this->load->view('backend/include/footer',$data);
		}
	}

    function sendTestEmails() {
        if(isset($_POST['testemail'])) {
            $to=$_POST['testemail'];
            $type = $_POST['type'];
            $subject="Test email for ".$_POST['type'];
            $bodyhead="<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>
            <html xmlns='http://www.w3.org/1999/xhtml'>
            <head>
            <meta http-equiv='Content-Type' content='text/html; charset=utf-8' />
            <title>".$this->ts_functions->getsettings('sitetitle','text')."</title>
            </head><body>";
            if( $this->ts_functions->getsettings('email','logoshow') == '1' ) {
                $body = "<img src='".$this->ts_functions->getsettings('logo','url')."' alt='".$this->ts_functions->getsettings('sitetitle','text')."'  title='".$this->ts_functions->getsettings('sitetitle','text')."'/>";
            }
            else {
                $body = '';
            }

            $link = "<a href='".base_url()."'>".$this->ts_functions->getsettings($type,'linktext')."</a>";
            $emContent = $this->ts_functions->getsettings($type,'text');
            $emContent = str_replace("[username]","username",$emContent);
            $emContent = str_replace("[break]","<br/>",$emContent);
            $emContent = str_replace("[linktext]",$link,$emContent);

            $body .="<p>".$emContent."</p>";

            $from = $this->ts_functions->getsettings('email','fromname');
            $from_add = $this->ts_functions->getsettings('email','fromemail');
            $headers = "MIME-Version: 1.0" . "\r\n";
            $headers .= "Content-type:text/html;charset=iso-8859-1" . "\r\n";
            $headers .= "From: =?UTF-8?B?". base64_encode($from) ."?= <$from_add>\r\n" .
            'Reply-To: '.$from . "\r\n" .
            'X-Mailer: PHP/' . phpversion();
            mail($to,$subject,$bodyhead.$body.'</body></html>',$headers, '-f'.$from_add);
            echo '1';
        }
        else {
            echo '0';
        }
        die();
    }
	/******* Email Section ENDS **************/

	/********* Testimonials Settings STARTS **********/

	function testimonials($tid='') {
	    $data['basepath'] = base_url();
	    if($tid != '') {
	        $data['solotesti'] = $this->DatabaseModel->access_database('ts_testimonial','select','',array('	testi_id'=>$tid));
	    }
	    else {
	        $data['solotesti'] = array();
	    }
	    $data['testi_details'] = $this->DatabaseModel->access_database('ts_testimonial','orderby',array('	testi_order','asc'),'');
	    $this->load->view('backend/include/header',$data);
		$this->load->view('backend/testimonials',$data);
		//$this->load->view('backend/include/footer',$data);
	}

	function add_testimonial() {
	    if(isset($_POST['clientname'])) {
	        $testiDataArr = array();
	        if($_FILES['clientimage']['name'] != ''){
	            $path=dirname(__FILE__);
                $abs_path=explode('/application/',$path);
                $pathToImages = $abs_path[0].'/assets/images/web/';

                $config['upload_path'] = $pathToImages;
                $config['allowed_types'] = 'jpg|jpeg|png';

                $this->load->library('upload', $config);
                $this->upload->initialize($config);

                if ($this->upload->do_upload('clientimage'))
                {
                    $randomstr = substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, 6);
                    $imgNewname = $randomstr;
                    $uploaddata=$this->upload->data();
                    $img_name = $uploaddata['raw_name'];
                    $img_ext = $uploaddata['file_ext'];
                    $imgNewname = $imgNewname.$img_ext;
                    rename($pathToImages.$img_name.$img_ext, $pathToImages.$imgNewname);
                    $testiDataArr['testi_image']=$imgNewname;
                }
	        }

	        $chk = (isset($_POST['clientdesignation_checkbox']) ? '1' : '0');
	        $testiDataArr['testi_name'] = $_POST['clientname'];
	        $testiDataArr['testi_showdesig'] = $chk;
	        $testiDataArr['testi_desig'] = $_POST['clientdesignation'];
	        $testiDataArr['testi_msg'] = $_POST['clientmsg'];

	        if($_POST['old_testid']=='0') {
	            $this->DatabaseModel->access_database('ts_testimonial','insert',$testiDataArr,'');
                $this->session->userdata['ts_success'] = 'Testimonial added successfully.';
            }
            else {
                $this->DatabaseModel->access_database('ts_testimonial','update',$testiDataArr, array('testi_id'=>$_POST['old_testid']));
                $this->session->userdata['ts_success'] = 'Testimonial updated successfully.';
            }

            redirect(base_url().'backend/testimonials');
	    }
	    else {
	        echo '0';
	    }
	    die();
	}

	function save_testimonial_order() {
	    if(isset($_POST['testi_id'])) {
            $testi_array= explode(',',$_POST['testi_id']);
            $ord = 0;
            for($i=0; $i<count($testi_array); $i++){
                $ord++;
                $testiID = $testi_array[$i];
                $this->DatabaseModel->access_database('ts_testimonial','update', array('testi_order'=>$ord) , array('testi_id'=>$testiID));
            }
            echo '1';
	    }
	    else {
	        echo '0';
	    }
	    die();
	}

	/********* Testimonials Settings ENDS **********/

	/********* Category Settings STARTS **********/

	function categories($cid='') {
	    $data['basepath'] = base_url();
	    if($cid != '') {
	        $data['solocate'] = $this->DatabaseModel->access_database('ts_categories','select','',array('	cate_id'=>$cid));
	    }
	    else {
	        $data['solocate'] = array();
	    }
	    $data['cate_details'] = $this->DatabaseModel->access_database('ts_categories','select','','');
	    $this->load->view('backend/include/header',$data);
		$this->load->view('backend/category_page',$data);
		$this->load->view('backend/include/footer',$data);
	}

	function add_categories() {
	    if(isset($_POST['catename'])) {
	        $cateDataArr = array();
            if( $_POST['catename'] != '' ) {
                $cateDataArr['cate_name'] = $_POST['catename'];

                if($_POST['old_cateid']=='0') {
                    $this->DatabaseModel->access_database('ts_categories','insert',$cateDataArr,'');
                    $this->session->userdata['ts_success'] = 'Category added successfully.';
                }
                else {
                    $this->DatabaseModel->access_database('ts_categories','update',$cateDataArr, array('cate_id'=>$_POST['old_cateid']));
                    $this->session->userdata['ts_success'] = 'Category updated successfully.';
                }
            }
            else {
                $this->session->userdata['ts_error'] = "Category can not be added.";
            }

            redirect(base_url().'backend/categories');
	    }
	    else {
	        echo '0';
	    }
	    die();
	}

	/********* Category Settings ENDS **********/

	/************ Compliance Page STARTS *****************/
	function compliance_pages(){
	    if(isset($_POST['pageSection'])) {
	    // Ajax
	        $pageSection = json_decode($_POST['pageSection']);
	        foreach( $pageSection as $soloKey=>$soloValue ) {
	            $colArr = explode('V7',$soloKey);
	            if(count($colArr) == 2) {
	                $this->DatabaseModel->access_database('ts_pages','update', array($colArr[0]=>$soloValue) , array('page_type'=>$pageSection->typee));
	            }
	        }
	        echo '1';
	    }
	    else {
            $data['pageSection'] = $this->DatabaseModel->access_database('ts_pages','select', '' , '');
            $data['basepath'] = base_url();
            $this->load->view('backend/include/header',$data);
            $this->load->view('backend/compliance_pages',$data);
		}
	}
	/************ Compliance Page ENDS *****************/

	/************ Transaction History STARTS *******************/

	function transaction_history(){
	    $data['transactionDetails'] = $this->DatabaseModel->access_database('ts_paymentdetails','select', '' , '');
	    $data['totalTransaction'] = $this->DatabaseModel->access_database('ts_paymentdetails','totalvalue', array('payment_amount','totalAmount') , array('payment_status'=>'yes'));

        $data['basepath'] = base_url();
        $this->load->view('backend/include/header',$data);
        $this->load->view('backend/transaction_history',$data);
        $this->load->view('backend/include/footer',$data);
	}

    function transaction_history_detail(){
        if(isset($_POST['currentId'])){

            $join_array = array('ts_user','ts_user.user_id = ts_paymentdetails.payment_uid');
		    $transactionDetails = $this->DatabaseModel->access_database('ts_paymentdetails','','',array('payment_id'=>$_POST['currentId']),$join_array);

            if(empty($transactionDetails)) {
                echo '<p>Data can not be fetched.</p>';
            }
            else {
                $custom = trim($transactionDetails[0]['payment_pid']);
                $customArr = explode(',',$custom);
                $outputStr = '';

                $outputStr .= '<p> User Details </p> <p> Username : <b>'.$transactionDetails[0]['user_uname'].'</b></p> <p> Email : <b>'.$transactionDetails[0]['user_email'].'</b></p> <p> Registration Date : <b>'.date_format(date_create ( $transactionDetails[0]['user_registerdate'] ) , 'M d, Y').'</b></p> <p> Transaction Mode : <b>'.ucfirst($transactionDetails[0]['payment_mode']).'</b></p> <hr />';

                for($i=0;$i<count($customArr);$i++) {

                    $pId = $customArr[$i];
                    $findPlan = $this->DatabaseModel->access_database('ts_plans','select','',array('plan_id'=>$pId,'plan_status'=>1));

                    $findProduct = $this->DatabaseModel->access_database('ts_products','select','',array('prod_uniqid'=>$pId,'prod_status'=>1));

                    if(!empty($findPlan) || !empty($findProduct)) {

                        if(!empty($findPlan)) {
                            $outputStr .= '<p> Product Name : <b>'.$findPlan[0]['plan_name'].'</b></p>';
                            $outputStr .= '<p> Product Amount : <b>'.$this->ts_functions->getsettings('portal','curreny').' '.$findPlan[0]['plan_amount'].'</b></p><hr />';
                        }

                        if(!empty($findProduct)) {
                            $outputStr .= '<p> Product Name : <b>'.$findProduct[0]['prod_name'].'</b></p>';
                            $outputStr .= '<p> Product Amount : <b>'.$this->ts_functions->getsettings('portal','curreny').' '.$findProduct[0]['prod_price'].'</b></p><hr />';
                        }
                    }
                }
                echo $outputStr;
            }
        }
        else {
            echo '<p>Data can not be fetched.</p>';
        }
        die();
    }
	/************ Transaction History STARTS *******************/

}
?>
