<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Pages extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
	    $this->load->library('ts_functions');
	}


    /************ Custom pages after payment STARTS *******************************/

    function canceled_payment($type='') {
        if($type != '') {
            setcookie("cartCookies", '1' , time()-3600 * 24 * 90,'/');
            $data['basepath'] = base_url();
            $data['pagetype_toptext'] = 'payCanceledHeading';
            $data['pagetype_heading'] = $type.'Cancelh3';
            $data['pagetype_text'] = $type.'Canceltext';
            $this->load->view('home/include/home_header',$data);
            $this->load->view('home/include/menu_header',$data);
            $this->load->view('home/oops',$data);
            $this->load->view('home/include/home_footer',$data);
        }
        else {
            redirect(base_url());
        }
    }

    function notify_payment() {
        if(isset($_POST['payer_id'])) {
            $custom = trim($_POST['custom']);
            $customArr = explode(',',$custom);
            $payment_uniqid = $_POST['item_number'];
            $checkPaymentDetails = $this->DatabaseModel->access_database('ts_paymentdetails','select','',array('payment_uniqid'=>$payment_uniqid));

            if( !empty($checkPaymentDetails) ) {
            if( $checkPaymentDetails[0]['payment_status'] == 'no' ) {
                for($i=0;$i<count($customArr);$i++) {

                    $pId = $customArr[$i];
                    $findPlan = $this->DatabaseModel->access_database('ts_plans','select','',array('plan_id'=>$pId,'plan_status'=>1));

                    $findProduct = $this->DatabaseModel->access_database('ts_products','select','',array('prod_uniqid'=>$pId,'prod_status'=>1));

                    if(!empty($findPlan) || !empty($findProduct)) {

                        $userId = $checkPaymentDetails[0]['payment_uid'];

                        if(!empty($findPlan)) {
                            // Update Plan
                            $this->DatabaseModel->access_database('ts_user','update',array('user_plans'=>$findPlan[0]['plan_id'] , 'user_plansdate' => date('Y-m-d H:i:s')),array('user_id'=>$userId));
                        }

                        if(!empty($findProduct)) {
                            // Add Products to purchase
                            $prodId = $findProduct[0]['prod_id'];
                            $purchaseRecord = $this->DatabaseModel->access_database('ts_purchaserecord','select','',array('purrec_prodid'=>$prodId,'purrec_uid'=>$userId));
                            if(empty($purchaseRecord)) {
                                $purDataArr = array(
                                    'purrec_prodid'=>$prodId,
                                    'purrec_date'=>date('Y-m-d H:i:s'),
                                    'purrec_purcode'=>md5($payment_uniqid),
                                    'purrec_uid'=>$userId
                                );
                                $this->DatabaseModel->access_database('ts_purchaserecord','insert',$purDataArr,'');
                            }
                        }

                        $this->DatabaseModel->access_database('ts_paymentdetails','update',array('payment_status'=>'yes','payment_amount'=>$_POST['mc_gross']),array('payment_uniqid'=>$payment_uniqid));

                    }
                }
            }
            }
        }
    }


    function success_payment($type='') {
        if($type != '') {
            setcookie("cartCookies", '1' , time()-3600 * 24 * 90,'/');
            $data['basepath'] = base_url();
            $data['pagetype_toptext'] = 'paySuccessHeading';
            $data['pagetype_heading'] = $type.'Successh3';
            $data['pagetype_text'] = $type.'Successtext';
            $this->load->view('home/include/home_header',$data);
            $this->load->view('home/include/menu_header',$data);
            $this->load->view('home/success',$data);
            $this->load->view('home/include/home_footer',$data);
        }
        else {
            redirect(base_url());
        }
    }

    /************ Custom pages after payment ENDS *******************************/

    /***************** Paypal IPN STARTS *************************/

    function paypal_ipn() {
        if(isset($_POST['payer_id'])) {
            $custom = trim($_POST['custom']);
            $customArr = explode(',',$custom);
            $payment_uniqid = $_POST['item_number'];
            $checkPaymentDetails = $this->DatabaseModel->access_database('ts_paymentdetails','select','',array('payment_uniqid'=>$payment_uniqid));

            if( !empty($checkPaymentDetails) ) {
            if( $checkPaymentDetails[0]['payment_status'] == 'no' ) {
                for($i=0;$i<count($customArr);$i++) {

                    $pId = $customArr[$i];
                    $findPlan = $this->DatabaseModel->access_database('ts_plans','select','',array('plan_id'=>$pId,'plan_status'=>1));

                    $findProduct = $this->DatabaseModel->access_database('ts_products','select','',array('prod_uniqid'=>$pId,'prod_status'=>1));

                    if(!empty($findPlan) || !empty($findProduct)) {

                        $userId = $checkPaymentDetails[0]['payment_uid'];

                        if(!empty($findPlan)) {
                            // Update Plan
                            $this->DatabaseModel->access_database('ts_user','update',array('user_plans'=>$findPlan[0]['plan_id'] , 'user_plansdate' => date('Y-m-d H:i:s')),array('user_id'=>$userId));
                        }

                        if(!empty($findProduct)) {
                            // Add Products to purchase
                            $prodId = $findProduct[0]['prod_id'];
                            $purchaseRecord = $this->DatabaseModel->access_database('ts_purchaserecord','select','',array('purrec_prodid'=>$prodId,'purrec_uid'=>$userId));
                            if(empty($purchaseRecord)) {
                                $purDataArr = array(
                                    'purrec_prodid'=>$prodId,
                                    'purrec_date'=>date('Y-m-d H:i:s'),
                                    'purrec_purcode'=>md5($payment_uniqid),
                                    'purrec_uid'=>$userId
                                );
                                $this->DatabaseModel->access_database('ts_purchaserecord','insert',$purDataArr,'');
                            }
                        }

                        $this->DatabaseModel->access_database('ts_paymentdetails','update',array('payment_status'=>'yes','payment_amount'=>$_POST['mc_gross']),array('payment_uniqid'=>$payment_uniqid));

                    }
                }
            }
            }
        }
    }

    /***************** Paypal IPN ENDS *************************/

    /*********** PayU Money *******************/
    /************ Custom pages after payment STARTS *******************************/

    function payu_canceled_payment() {
        setcookie("cartCookies", '1' , time()-3600 * 24 * 90,'/');
        $data['basepath'] = base_url();
        $data['pagetype_toptext'] = 'payCanceledHeading';
        $data['pagetype_heading'] = 'paypalCancelh3';
        $data['pagetype_text'] = 'payuCanceltext';
        $this->load->view('home/include/home_header',$data);
        $this->load->view('home/include/menu_header',$data);
        $this->load->view('home/oops',$data);
        $this->load->view('home/include/home_footer',$data);
    }

    function payu_failed_payment(){
        setcookie("cartCookies", '1' , time()-3600 * 24 * 90,'/');
        $data['basepath'] = base_url();
        $data['pagetype_toptext'] = 'payCanceledHeading';
        $data['pagetype_heading'] = 'paypalCancelh3';
        $data['pagetype_text'] = 'payuCanceltext';
        $this->load->view('home/include/home_header',$data);
        $this->load->view('home/include/menu_header',$data);
        $this->load->view('home/oops',$data);
        $this->load->view('home/include/home_footer',$data);
    }

    function payu_success_payment() {

        $status=$_POST["status"];
        $firstname=$_POST["firstname"];
        $amount=$_POST["amount"];
        $txnid=$_POST["txnid"];
        $posted_hash=$_POST["hash"];
        $key=$_POST["key"];
        $productinfo=$_POST["productinfo"];
        $email=$_POST["email"];
        $salt=$this->ts_functions->getsettings('payu','merchantSalt');

        if (isset($_POST["additionalCharges"])) {
            $additionalCharges=$_POST["additionalCharges"];
            $retHashSeq = $additionalCharges.'|'.$salt.'|'.$status.'|||||||||||'.$email.'|'.$firstname.'|'.$productinfo.'|'.$amount.'|'.$txnid.'|'.$key;

        }
        else {
            $retHashSeq = $salt.'|'.$status.'|||||||||||'.$email.'|'.$firstname.'|'.$productinfo.'|'.$amount.'|'.$txnid.'|'.$key;
        }
        $hash = hash("sha512", $retHashSeq);

        if ($hash != $posted_hash) {
        //echo "Invalid Transaction. Please try again";

            setcookie("cartCookies", '1' , time()-3600 * 24 * 90,'/');
            $data['basepath'] = base_url();
            $data['pagetype_toptext'] = 'payCanceledHeading';
            $data['pagetype_heading'] = 'paypalCancelh3';
            $data['pagetype_text'] = 'payuCanceltext';
            $this->load->view('home/include/home_header',$data);
            $this->load->view('home/include/menu_header',$data);
            $this->load->view('home/oops',$data);
            $this->load->view('home/include/home_footer',$data);

        }
        else {

            $payment_uniqid = $txnid;
            $checkPaymentDetails = $this->DatabaseModel->access_database('ts_paymentdetails','select','',array('payment_uniqid'=>$payment_uniqid));

            if( !empty($checkPaymentDetails) ) {
            if( $checkPaymentDetails[0]['payment_status'] == 'no' ) {
                $custom = trim($checkPaymentDetails[0]['payment_pid']);
                $customArr = explode(',',$custom);

                for($i=0;$i<count($customArr);$i++) {

                    $pId = $customArr[$i];
                    $findPlan = $this->DatabaseModel->access_database('ts_plans','select','',array('plan_id'=>$pId,'plan_status'=>1));

                    $findProduct = $this->DatabaseModel->access_database('ts_products','select','',array('prod_uniqid'=>$pId,'prod_status'=>1));

                    if(!empty($findPlan) || !empty($findProduct)) {

                        $userId = $checkPaymentDetails[0]['payment_uid'];

                        if(!empty($findPlan)) {
                            // Update Plan
                            $this->DatabaseModel->access_database('ts_user','update',array('user_plans'=>$findPlan[0]['plan_id'] , 'user_plansdate' => date('Y-m-d H:i:s')),array('user_id'=>$userId));
                        }

                        if(!empty($findProduct)) {
                            // Add Products to purchase
                            $prodId = $findProduct[0]['prod_id'];
                            $purchaseRecord = $this->DatabaseModel->access_database('ts_purchaserecord','select','',array('purrec_prodid'=>$prodId,'purrec_uid'=>$userId));
                            if(empty($purchaseRecord)) {
                                $purDataArr = array(
                                    'purrec_prodid'=>$prodId,
                                    'purrec_date'=>date('Y-m-d H:i:s'),
                                    'purrec_purcode'=>md5($payment_uniqid),
                                    'purrec_uid'=>$userId
                                );
                                $this->DatabaseModel->access_database('ts_purchaserecord','insert',$purDataArr,'');
                            }
                        }
                        $this->DatabaseModel->access_database('ts_paymentdetails','update',array('payment_status'=>'yes','payment_amount'=>$amount),array('payment_uniqid'=>$payment_uniqid));

                    }
                }

                setcookie("cartCookies", '1' , time()-3600 * 24 * 90,'/');
                $data['basepath'] = base_url();
                $data['pagetype_toptext'] = 'paySuccessHeading';
                $data['pagetype_heading'] = 'paypalSuccessh3';
                $data['pagetype_text'] = 'paypalSuccesstext';
                $this->load->view('home/include/home_header',$data);
                $this->load->view('home/include/menu_header',$data);
                $this->load->view('home/success',$data);
                $this->load->view('home/include/home_footer',$data);

            }
            }
            else {

                setcookie("cartCookies", '1' , time()-3600 * 24 * 90,'/');
                $data['basepath'] = base_url();
                $data['pagetype_toptext'] = 'payCanceledHeading';
                $data['pagetype_heading'] = 'paypalCancelh3';
                $data['pagetype_text'] = 'payuCanceltext';
                $this->load->view('home/include/home_header',$data);
                $this->load->view('home/include/menu_header',$data);
                $this->load->view('home/oops',$data);
                $this->load->view('home/include/home_footer',$data);

            }

        }

    }

    /************ Custom pages after payment ENDS *******************************/

}
