<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Shop extends CI_Controller {

	public function __construct()
	{
		parent::__construct();

		if(isset($_POST) && !empty($_POST)) {
	        if(!isset($_SERVER['HTTP_REFERER'])) {
                die('Direct Access Not Allowed!!');
	        }
	    }
	    $this->load->library('ts_functions');
	}

    /*********** Check Product Plan and User's Membership  STARTS *******************/

    function checkmembership($prodid='') {
        if($prodid != '') {
            if( isset($this->session->userdata['ts_uid']) ) {
                $uid = $this->session->userdata['ts_uid'];
                $userDetail = $this->DatabaseModel->access_database('ts_user','select','',array('user_id'=>$this->session->userdata('ts_uid')));

                if( $userDetail[0]['user_plans'] == 0 ) {
                    // No plan selected by user
                    $this->session->set_flashdata('plan_message', 'Upgrade your plan to access this product.');
                    redirect(base_url().'home/plans_pricing');
                }

                $prodDetail = $this->DatabaseModel->access_database('ts_products','select','',array('prod_uniqid'=>$prodid,'prod_status'=>1));
                if(!empty($prodDetail)) {
                    redirect(base_url().'dashboard/purchased');
                }
                else {
                    redirect(base_url());
                }
            }
            else {
                redirect(base_url().'home/plans_pricing');
            }
        }
        else {
            redirect(base_url());
        }
    }

    /*********** Check Product Plan and User's Membership ENDS *******************/

    /*********** Add Products to Cart STARTS *******************/
    function add_to_cart($type='',$id = ''){
        if($type == 'plan') {
            $details = $this->DatabaseModel->access_database('ts_plans','select','',array('plan_id'=>$id,'plan_status'=>1));
        }
        else {
            $details = $this->DatabaseModel->access_database('ts_products','select','',array('prod_uniqid'=>$id,'prod_status'=>1));
        }
        if( !empty($details) ) {

            /***** check for FREE products STARTS *******/

            if( isset($details[0]['prod_free']) && $details[0]['prod_free'] == '1' ) {
                if( isset($this->session->userdata['ts_uid']) ) {
                    redirect(base_url().'dashboard/free_downloads');
                }
                else {
                    redirect(base_url().'authenticate/login');
                }
            }
            /***** check for FREE products ENDS *******/

            /***** check for FREE products STARTS *******/

            if( isset($details[0]['prod_plan']) && $details[0]['prod_plan'] == '1' ) {
                if( isset($this->session->userdata['ts_uid']) ) {
                    redirect(base_url().'dashboard/free_downloads');
                }
                else {
                    redirect(base_url().'authenticate/login');
                }
            }
            /***** check for FREE products ENDS *******/


            if(!isset($_COOKIE['cartCookies'])){
                $cartArr = array();
                $str = base64_encode($type.'#'.$id);
                array_push($cartArr,$str);
            }
            else {
                $cartArr = json_decode($_COOKIE['cartCookies'],true);
                $err = 0;
                for($i=0;$i<count($cartArr);$i++) {
                    $prodDetails = base64_decode($cartArr[$i]);
                    $prodDetailsArr = explode('#',$prodDetails);

                    if($prodDetailsArr[1] == $id) {
                        $err++;
                    }
                }
                if( $err == '0' ) {
                    $str = base64_encode($type.'#'.$id);
                    array_push($cartArr,$str);
                }
            }
            setcookie("cartCookies", json_encode($cartArr,true) , time()+3600 * 24 * 90,'/');
            redirect(base_url().'shop/cart');
        }
        else {
            redirect(base_url());
        }
    }
    /*********** Buy plans ENDS *******************/


    /*********** Buy plans STARTS *******************/
    function cart(){
        $cartArr = isset($_COOKIE['cartCookies']) ? json_decode($_COOKIE['cartCookies'],true) : array() ;

        if(empty($cartArr)) { redirect(base_url()); }
        $data['cartArr'] = $cartArr;
        $data['basepath'] = base_url();
		$this->load->view('home/include/home_header',$data);
		$this->load->view('home/include/menu_header',$data);
		$this->load->view('home/cart',$data);
		$this->load->view('home/include/home_footer',$data);

    }
    /*********** Buy plans ENDS *******************/

    /*********** Remove Cart STARTS *******************/
    function remove_cart($key='') {
        $cartArr = isset($_COOKIE['cartCookies']) ? json_decode($_COOKIE['cartCookies'],true) : array() ;
        if(empty($cartArr)) { redirect(base_url()); }
        $newCartArr = array();
        for($i=0;$i<count($cartArr);$i++) {
            if($i != $key) {
                array_push($newCartArr,$cartArr[$i]);
            }
        }

        setcookie("cartCookies", json_encode($newCartArr,true) , time()+3600 * 24 * 90,'/');
        redirect(base_url().'shop/cart');
    }
    /*********** Remove Cart ENDS *******************/

    /*********** Initiate payment depending on option STARTS *******************/
    function proceed_payment() {
        if(isset($_POST['paymentmethod'])) {
            $cartArr = isset($_COOKIE['cartCookies']) ? json_decode($_COOKIE['cartCookies'],true) : array() ;

            if(empty($cartArr)) { echo 'empty'; } else {
                $prodStr = $prodCode = '';
                $prodAmount = array();
                for($i=0;$i<count($cartArr);$i++) {
                    $prodDetails = base64_decode($cartArr[$i]);
                    $prodDetailsArr = explode('#',$prodDetails);
                    if( count($prodDetailsArr) == '2' ) {
                        $id = $prodDetailsArr[1];
                        if( $prodDetailsArr[0] == 'products' ) {
                            $details = $this->DatabaseModel->access_database('ts_products','select','',array('prod_uniqid'=>$id,'prod_status'=>1));
                            if(!empty($details)) {
                                $prodStr .= $details[0]['prod_name'].' , ';
                                $prodCode .= $details[0]['prod_uniqid'].' , ';
                                array_push($prodAmount,$details[0]['prod_price']);
                            }
                        }
                        else {
                            $details = $this->DatabaseModel->access_database('ts_plans','select','',array('plan_id'=>$id,'plan_status'=>1));
                            if(!empty($details)) {
                                $prodStr .= $details[0]['plan_name'].' , ';
                                $prodCode .= $details[0]['plan_id'].' , ';
                                array_push($prodAmount,$details[0]['plan_amount']);
                            }
                        }

                    }
                }

                $finalItemName = rtrim( trim($prodStr) ,',');
                $finalItemNumber = rtrim( trim($prodCode) ,',');

                $finalItemAmount = array_sum($prodAmount);

                $userDetail = $this->DatabaseModel->access_database('ts_user','select','',array('user_id'=>$this->session->userdata('ts_uid')));

                if(!empty($userDetail)) {

                /*** Track Payment Details *****/

                    $paymentArr = array(
                        'payment_uid'   =>  $this->session->userdata('ts_uid'),
                        'payment_pid'   =>  $finalItemNumber
                    );
                    $checkPreviousPayment = $this->DatabaseModel->access_database('ts_paymentdetails','select','',$paymentArr);

                    if( empty($checkPreviousPayment) ) {
                        $payUniqid = substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, 8);
                        $paymentArr['payment_uniqid'] = $payUniqid;
                        $paymentArr['payment_date'] = date('Y-m-d H:i:s');
                        $paymentArr['payment_mode'] = $_POST['paymentmethod'];

                        $this->DatabaseModel->access_database('ts_paymentdetails','insert',$paymentArr,'');

                    }
                    else {

                        if( $_POST['paymentmethod'] == 'paypal' ) {
                            $payUniqid = $checkPreviousPayment[0]['payment_uniqid'];
                        }
                        else {
                            $payUniqid = substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, 8);
                        }
                        $this->DatabaseModel->access_database('ts_paymentdetails','update',array('payment_date'=>date('Y-m-d H:i:s'), 'payment_uniqid'=>$payUniqid),array('	payment_id'=>$checkPreviousPayment[0]['payment_id']));
                    }

                    $trackingItemNumber = $payUniqid;  // UNIQUE TRANSACTION ID

                    /*** Track Payment Details *****/

                    if( $_POST['paymentmethod'] == 'paypal' ) {
                    $formData =
                          '<form action="https://www.paypal.com/cgi-bin/webscr" method="post" name="pay_form_name">
                          <input type="hidden" name="business" value="'.$this->ts_functions->getsettings('paypal','email').'">
                          <input type="hidden" name="item_name" value="'.$finalItemName.'">
                          <input type="hidden" name="amount" value="'.$finalItemAmount.'">
                          <input type="hidden" name="item_number" value="'.$trackingItemNumber.'">
                          <input type="hidden" name="no_shipping" value="1">
                          <input type="hidden" name="currency_code" value="'.$this->ts_functions->getsettings('portal','curreny').'">
                          <input type="hidden" name="cmd" value="_xclick">
                          <input type="hidden" name="handling" value="0">
                          <input type="hidden" name="no_note" value="1">
                          <input type="hidden" name="cpp_logo_image" value="'.$this->ts_functions->getsettings('logo','url').'">
                          <input type="hidden" name="custom" value="'.$finalItemNumber.'">
                          <input type="hidden" name="cancel_return" value="'.base_url().'pages/canceled_payment/paypal">
                          <input type="hidden" name="return" value="'.base_url().'pages/success_payment/paypal">
                            <input type="hidden" name="notify_url" value="'.base_url().'pages/notify_payment">
                         </form>';
                    }
                    else  {
                        $MERCHANT_KEY = $this->ts_functions->getsettings('payu','merchantKey');

                        $SALT = $this->ts_functions->getsettings('payu','merchantSalt');

                        $txnid = $trackingItemNumber;

                        $hash_string = $MERCHANT_KEY.'|'.$txnid.'|'.$finalItemAmount.'|'.$finalItemName.'|'.$this->session->userdata('ts_uname').'|'.$userDetail[0]['user_email'].'|||||||||||'.$SALT;
                        $hash = strtolower(hash('sha512', $hash_string));

                    $formData =
                         '<form action="https://secure.payu.in/_payment" method="post" name="payuForm">
                          <input type="hidden" name="key" value="'.$this->ts_functions->getsettings('payu','merchantKey').'" />
                          <input type="hidden" name="hash" value="'.$hash.'"/>
                          <input type="hidden" name="txnid" value="'.$txnid.'" />
                          <input type="hidden" name="amount" value="'.$finalItemAmount.'" />
                          <input type="hidden" name="firstname" id="firstname" value="'.$this->session->userdata('ts_uname').'" />
                          <input type="hidden" name="email" id="email" value="'.$userDetail[0]['user_email'].'" />
                          <input type="hidden" name="phone" value="'.$userDetail[0]['user_mobile'].'" />
                          <input type="hidden" name="productinfo" value="'.$finalItemName.'" />
                          <input type="hidden" name="surl" value="'.base_url().'pages/payu_success_payment">
                          <input type="hidden" name="furl" value="'.base_url().'pages/payu_failed_payment">
                          <input type="hidden" name="curl" value="'.base_url().'pages/payu_canceled_payment">
                          <input type="hidden" name="service_provider" value="payu_paisa">
                         </form>';
                    }
                    echo $formData;
                }
                else {
                    echo 0;
                }
            }
        }
        else {
            echo 0;
        }
        die();

    }
    /*********** Initiate payment depending on option ENDS *******************/

}
